#ifndef __node__
#define __node__

/********/
/*      */
/* Node */
/*      */
/********/

class Node
{

public:
    Node *getnext();

protected:
    class Node *next;

}; /* end class Node */

inline Node *Node::getnext() { return next; }

/**************/
/*            */
/* Sspvarnode */
/*            */
/**************/

class Sspvar;

class Sspvarnode : public Node
{

public:
    Sspvarnode(Sspvar *);

    void setnext(Sspvarnode *);
    Sspvar *thisone();

private:
    Sspvar *p;

}; /* end class Sspvarnode */

inline Sspvarnode::Sspvarnode(Sspvar *fp) { p = fp; }
inline void Sspvarnode::setnext(Sspvarnode *np) { next = np; }
inline Sspvar *Sspvarnode::thisone() { return p; }

/***************/
/*             */
/* Burtobjnode */
/*             */
/***************/

class Burtobj;

class Burtobjnode : public Node
{

public:
    Burtobjnode(Burtobj *);

    void setnext(Burtobjnode *);
    Burtobj *thisone();

private:
    Burtobj *p;

}; /* end class Burtobjnode */

inline Burtobjnode::Burtobjnode(Burtobj *fp) { p = fp; }
inline void Burtobjnode::setnext(Burtobjnode *np) { next = np; }
inline Burtobj *Burtobjnode::thisone() { return p; }

/*******************/
/*                 */
/* Burtobjlistnode */
/*                 */
/*******************/

class Burtobjlist;

class Burtobjlistnode : public Node
{

public:
    Burtobjlistnode(Burtobjlist *);

    void setnext(Burtobjlistnode *);
    Burtobjlist *thisone();

private:
    Burtobjlist *p;

}; /* end class Burtobjlistnode */

inline Burtobjlistnode::Burtobjlistnode(Burtobjlist *fp) { p = fp; }
inline void Burtobjlistnode::setnext(Burtobjlistnode *np) { next = np; }
inline Burtobjlist *Burtobjlistnode::thisone() { return p; }

/*****************/
/*               */
/* Predicatenode */
/*               */
/*****************/

class Predicate;

class Predicatenode : public Node
{

public:
    Predicatenode(Predicate *);

    void setnext(Predicatenode *);
    Predicate *thisone();

private:
    Predicate *p;

}; /* end class Predicatenode */

inline Predicatenode::Predicatenode(Predicate *fp) { p = fp; }
inline void Predicatenode::setnext(Predicatenode *np) { next = np; }
inline Predicate *Predicatenode::thisone() { return p; }

/***************/
/*             */
/* Iocpvarnode */
/*             */
/***************/

class Iocpvar;

class Iocpvarnode : public Node
{

public:
    Iocpvarnode(Iocpvar *);

    void setnext(Iocpvarnode *);
    Iocpvar *thisone();

private:
    Iocpvar *p;

}; /* end class Iocpvarnode */

inline Iocpvarnode::Iocpvarnode(Iocpvar *fp) { p = fp; }
inline void Iocpvarnode::setnext(Iocpvarnode *np) { next = np; }
inline Iocpvar *Iocpvarnode::thisone() { return p; }

#endif
