/*************************************************************************\
* Copyright (c) 2002 The University of Chicago, as Operator of Argonne
* National Laboratory.
* Copyright (c) 2002 The Regents of the University of California, as
* Operator of Los Alamos National Laboratory.
* This file is distributed subject to a Software License Agreement found
* in the file LICENSE that is included with this distribution. 
\*************************************************************************/
/*********************/
/*                   */
/* Utility Functions */
/*                   */
/*********************/

BOOL BurtCreateUniqueFilename();
void clear_scrolled_text();
Pixel color_string_to_pixel();
BOOL file_exists();
void file_to_scrolled_text();
void popup_error();
void popup_message();
void verify_int_cb();
void print_file();
void set_not_ok();
void set_ok();
void set_running();

/********************/
/*                  */
/* Shared Callbacks */
/*                  */
/********************/

void shared_done_button_cb();
void shared_print_log_button_cb();
void shared_temp_help_button_cb();
