/*************************************************************************\
* Copyright (c) 2002 The University of Chicago, as Operator of Argonne
* National Laboratory.
* Copyright (c) 2002 The Regents of the University of California, as
* Operator of Los Alamos National Laboratory.
* This file is distributed subject to a Software License Agreement found
* in the file LICENSE that is included with this distribution. 
\*************************************************************************/
#ifndef __burtpublic__
#define __burtpublic__

#define NULLSTRING "\\0"

/* Start SDDS Snapshot Parameters */
#define TIMEHEADERSTRING     "TimeStamp"
#define LOGINHEADERSTRING    "LoginID"
#define EFFUIDHEADERSTRING   "EffectiveUID"
#define GROUPIDHEADERSTRING  "GroupID"
#define KEYWORDSHEADERSTRING "BurtKeywords"
#define COMMENTSHEADERSTRING "BurtComments"
#define TYPEHEADERSTRING     "SnapType"
/* End SDDS Snapshot Parameters */

#define READONLYSTRING       "RO"
#define READONLYNOTIFYSTRING "RON"

#define ABSOLUTESTRING "Absolute"
#define RELATIVESTRING "Relative"
#define NOWRITESTRING  "Nowrite"

/* Start SDDS */
/* column names */
#define NAME_COL     "ControlName"
#define TYPE_COL     "ControlType"
#define LINEAGE_COL  "Lineage"
#define READMSG_COL  "BackupMsg"
#define WRITEMSG_COL "RestoreMsg"
#define NELEM_COL    "Count"
#define MODE_COL     "ControlMode"
#define VAL_COL      "ValueString"

/* string constants found in req files */
#define PVSTRING  "pv"
#define DEVSTRING "dev"

/* default messages */
#define DEFAULTREADMSG  "read"
#define DEFAULTWRITEMSG "set"

#define DEFAULTSTRING    "-"
#define LINEAGEDELIMETER ","

/* End SDDS */

#define UNKNOWN              -1
#define UNKNOWNLOGINID       "Unknown"
#define UNKNOWNREALWORLDNAME "Unknown"
#define UNKNOWNTIME          "Unknown"

#endif
