/*************************************************************************\
* Copyright (c) 2002 The University of Chicago, as Operator of Argonne
* National Laboratory.
* Copyright (c) 2002 The Regents of the University of California, as
* Operator of Los Alamos National Laboratory.
* This file is distributed subject to a Software License Agreement found
* in the file LICENSE that is included with this distribution. 
\*************************************************************************/
String fallback_resources[] =
    {
	"*fontList:  6x13",

	"*background:  MidnightBlue",
	"*XmPushButton.background:  DodgerBlue",

	/**************/
	/*            */
	/* main shell */
	/*            */
	/**************/

	"*form.fractionBase: 8",

	"*read_button.labelString:      Backup",
	"*read_button.leftAttachment:   XmATTACH_FORM",
	"*read_button.topAttachment:    XmATTACH_FORM",
	"*read_button.rightAttachment:  XmATTACH_POSITION",
	"*read_button.rightPosition:    1",
	"*read_button.bottomAttachment: XmATTACH_FORM",

	"*write_button.labelString:      Restore",
	"*write_button.leftAttachment:   XmATTACH_WIDGET",
	"*write_button.leftWidget:       read_button",
	"*write_button.topAttachment:    XmATTACH_FORM",
	"*write_button.rightAttachment:  XmATTACH_POSITION",
	"*write_button.rightPosition:    2",
	"*write_button.bottomAttachment: XmATTACH_FORM",

	"*addsub_button.labelString:      Add/Sub",
	"*addsub_button.leftAttachment:   XmATTACH_WIDGET",
	"*addsub_button.leftWidget:       write_button",
	"*addsub_button.topAttachment:    XmATTACH_FORM",
	"*addsub_button.rightAttachment:  XmATTACH_POSITION",
	"*addsub_button.rightPosition:    3",
	"*addsub_button.bottomAttachment: XmATTACH_FORM",

	"*mult_button.labelString:      Mult",
	"*mult_button.leftAttachment:   XmATTACH_WIDGET",
	"*mult_button.leftWidget:       addsub_button",
	"*mult_button.topAttachment:    XmATTACH_FORM",
	"*mult_button.rightAttachment:  XmATTACH_POSITION",
	"*mult_button.rightPosition:    4",
	"*mult_button.bottomAttachment: XmATTACH_FORM",

	"*set_button.labelString:      Set",
	"*set_button.leftAttachment:   XmATTACH_WIDGET",
	"*set_button.leftWidget:       mult_button",
	"*set_button.topAttachment:    XmATTACH_FORM",
	"*set_button.rightAttachment:  XmATTACH_POSITION",
	"*set_button.rightPosition:    5",
	"*set_button.bottomAttachment: XmATTACH_FORM",

	"*definc_button.labelString:      Def/Inc",
	"*definc_button.leftAttachment:   XmATTACH_WIDGET",
	"*definc_button.leftWidget:       set_button",
	"*definc_button.topAttachment:    XmATTACH_FORM",
	"*definc_button.rightAttachment:  XmATTACH_POSITION",
	"*definc_button.rightPosition:    6",
	"*definc_button.bottomAttachment: XmATTACH_FORM",

	"*help_button.labelString:      Help",
	"*help_button.leftAttachment:   XmATTACH_WIDGET",
	"*help_button.leftWidget:       definc_button",
	"*help_button.topAttachment:    XmATTACH_FORM",
	"*help_button.rightAttachment:  XmATTACH_POSITION",
	"*help_button.rightPosition:    7",
	"*help_button.bottomAttachment: XmATTACH_FORM",

	"*done_button.labelString:      Done",
	"*done_button.leftAttachment:   XmATTACH_WIDGET",
	"*done_button.leftWidget:       help_button",
	"*done_button.topAttachment:    XmATTACH_FORM",
	"*done_button.rightAttachment:  XmATTACH_FORM",
	"*done_button.bottomAttachment: XmATTACH_FORM",

	/**************/
	/*            */
	/* read shell */
	/*            */
	/**************/

	"*read_req_file_sel.pattern: *.req",

	"*read_req_file_sel_button.labelString: Request Files ...",
	"*read_view_req_button.labelString:     View Selected ...",
	"*read_remove_button.labelString:       Remove Selected",
	"*read_clear_button.labelString:        Clear All",
	"*read_print_button.labelString:        Print Selected",

	"*read_read_button.labelString:      Backup",
	"*read_view_log_button.labelString:  View Log ...",
	"*read_print_log_button.labelString: Print Log",
	"*read_help_button.labelString:      Help ...",
	"*read_done_button.labelString:      Done",

	/* read log shell */
	"*read_log_done_button.labelString: Done",
	/* read view req shell */
	"*read_view_req_done_button.labelString: Done",

	/***************/
	/*             */
	/* write shell */
	/*             */
	/***************/

	"*write_snap_file_sel_button.labelString:     Snapshot Files ...",
	"*write_view_snap_button.labelString:         View Selected ...",
	"*write_remove_snap_button.labelString:       Remove Selected",
	"*write_clear_snap_button.labelString:        Clear All",
	"*write_print_snap_button.labelString:        Print Selected",
	/* write snapshot file selection box */
	"*write_snap_file_sel.pattern: *.snap",
	/* write view snapshot shell */
	"*write_view_snap_done_button.labelString: Done",

	"*write_dep_file_sel_button.labelString:     Dependency Files ...",
	"*write_view_dep_button.labelString:         View Selected ...",
	"*write_remove_dep_button.labelString:       Remove Selected",
	"*write_clear_dep_button.labelString:        Clear All",
	/* write dep file selection box */
	"*write_dep_file_sel.pattern: *.dep",
	/* write view dep shell */
	"*write_view_dep_done_button.labelString: Done",

	"*write_write_button.labelString:     Restore",
	"*write_view_log_button.labelString:  View Log ...",
	"*write_print_log_button.labelString: Print Log",
	"*write_help_button.labelString:      Help ...",
	"*write_done_button.labelString:      Done",

	/* write view log shell */
	"*write_log_done_button.labelString: Done",
	/* write view out shell */
	"*write_out_done_button.labelString: Done",
	"*write_out_print_button.labelString: Print",

	/**************/
	/*            */
	/* math shell */
	/*            */
	/**************/

	"*math_op1_snap_file_sel.pattern: *.snap",
	"*math_op1_snap_file_sel_button.labelString: Snapshot Files ...",
	"*math_op1_view_snap_button.labelString:     View ...",
	"*math_op1_print_snap_button.labelString:    Print",

	"*math_op2_snap_file_sel.pattern: *.snap",
	"*math_op2_snap_file_sel_button.labelString: Snapshot Files ...",
	"*math_op2_view_snap_button.labelString:     View ...",
	"*math_op2_print_snap_button.labelString:    Print",

	"*math_op3_snap_file_sel.pattern: *.snap",
	"*math_op3_snap_file_sel_button.labelString: Snapshot Files ...",
	"*math_op3_view_snap_button.labelString:     View ...",
	"*math_op3_print_snap_button.labelString:    Print",

	"*math_go1_button.labelString:       Go",
	"*math_view_log1_button.labelString: View Log ...",
	"*math_print_log1_button.labelString: Print Log",
	"*math_help1_button.labelString:     Help ...",
	"*math_done1_button.labelString:     Done",

	"*math_go2_button.labelString:       Go",
	"*math_view_log2_button.labelString: View Log ...",
	"*math_print_log2_button.labelString: Print Log",
	"*math_help2_button.labelString:     Help ...",
	"*math_done2_button.labelString:     Done",

	/* math log1 shell */
	"*math_log_done1_button.labelString: Done",
	/* math log2 shell */
	"*math_log_done2_button.labelString: Done",
	/* math op1 view snap shell */
	"*math_op1_view_snap_done_button.labelString: Done",
	/* math op2 view snap shell */
	"*math_op2_view_snap_done_button.labelString: Done",
	/* math op3 view snap shell */
	"*math_op3_view_snap_done_button.labelString: Done",

	/*************/
	/*           */
	/* set shell */
	/*           */
	/*************/

	"*set_op1_req_file_sel.pattern: *.req",
	"*set_op1_req_file_sel_button.labelString: Request Files ...",
	"*set_op1_view_req_button.labelString:     View ...",
	"*set_op1_print_req_button.labelString:    Print",

	"*set_op2_req_file_sel.pattern: *.req",
	"*set_op2_req_file_sel_button.labelString: Request Files ...",
	"*set_op2_view_req_button.labelString:     View ...",
	"*set_op2_print_req_button.labelString:    Print",

	"*set_go_button.labelString:       Go",
	"*set_view_log_button.labelString: View Log ...",
	"*set_print_log_button.labelString: Print Log",
	"*set_help_button.labelString:     Help ...",
	"*set_done_button.labelString:     Done",

	/* set log shell */
	"*set_log_done_button.labelString: Done",
	/* set op1 view req shell */
	"*set_op1_view_req_done_button.labelString: Done",
	/* set op2 view req shell */
	"*set_op2_view_req_done_button.labelString: Done",

	/****************/
	/*              */
	/* definc shell */
	/*              */
	/****************/

	"*definc_apply_button.labelString: Apply",
	"*definc_reset_button.labelString: Reset",
	"*definc_help_button.labelString:  Help ...",
	"*definc_done_button.labelString:  Done",

	(String) NULL
    };

